
; 17-a uzduotis:
; Parasykite programa, kuri iveda simboliu eilute ir atspausdina
; rastu skaitmenu skaiciu.
; Pvz.: ivedus 'abs 52d4' turi atspausdinti '3'

.model	small                            ;kodas ir duomenys yra skirtinguose segmentuose, bet maziau arba lygu uz 64kB
.stack	100h				
.data                                   

zinute		db	'Iveskite simboliu eilute...',0dh,0ah
		db	'[Enter] - pereiti i nauja eilute',0dh,0ah
		db	'----------------------------------',13,10
		db	13,10,36
	
eilute		db	256 dup(?)	

klaida		db	'Klaida: ivesta daugiau nei 256 simboliai!',13,10,36

desimt		dw	10	
	
.code 
main		proc

		mov	ax,@data        ;i AX segmenta patalpina DATA segmentini registra
		mov	ds,ax           ;ir i DS patalpina AX reiksme
		                       
		mov	ah,09h          ; kreipiasi su 9-a funkcija (eil isvedama i ekrana)
		lea	dx,zinute
		int	21h             

		lea	bx,eilute       ; i bx registra idedama eilute
		jmp	Laukia          

Nauja:		mov	ah,02h          ;2-a funkcija: isveda i ekrana simboli
		mov	dl,0dh          ;i dl pakraunama 0-ne reiksme
		int	21h             

		mov	ah,02h         
		mov	dl,0ah         
		int	21h             

		mov	si,0		; i SI iraso 0 (eilutes einamasis elementas)
		sub	di,di          
		jmp	Tikrina		

Laukia:		mov	ah,01h          ; isveda i ekrana tai, ka ivedi is klav, i al registra
		int	21h             

        ; tikrina eilutes ilgi
		mov	dx,bx		; i DX iraso BX adresa
		sub	dx,offset eilute 
		cmp	dx,256		
		jnc	Zyme		; >256

        ; baigiasi eilutes ilgio tikrinimas

		inc	bx		

		mov	[bx],al		; uzraso ivesta reiksme
		
		inc	bx              

		cmp	al,0dh		; Enter
		jz	Nauja		
		jmp	Laukia		

Zyme:		mov	ah,2		; isveda i ekrana 1 simb
		mov	dl,0dh		; i DL registra iraso 0dh
		int	21h		

		mov	ah,2		
		mov	dl,0ah		
		int	21h		

		mov	ah,9		; kreipiasi i 9-a funkcija
		lea	dx,klaida	; uzkrauna i DX kintamaji
		int	21h		

		jmp	Exit		

         ; ivestos eilutes apdorojimas
Tikrina:	mov	al,eilute[si]	; i AL iraso einamaji eilutes simboli
		cmp	al,0dh		
		jz	Iseiti		
		mov	cx,10		; iraso 
		mov	ah,30h		

Skaicius:	cmp	al,ah 		; tikrina: ar AL registre esanti reiksme lygi AH reiksmei, t.y. skaiciu
		jz	Taip		

Toliau:		inc	ah		
		loop	Skaicius
                cmp     al,'='
                jz      Taip
                cmp     al, '-'
                jz      Taip	        ; ciklas - ziuri CX reiksme ir vykto tol, kol ne 0
		inc	si		
		jmp	Tikrina		

Taip:		inc	si		; padidina skaitkliuka (einamasis eilutes simbolis)
		inc	di		
		jmp	Tikrina		
	
Iseiti:		mov	ax,di		; i AX registra iraso skaiciu kieki (16-ainis)
		sub	cx,cx		

Lauk:		sub	dx,dx		
		div	desimt		; dalina DX AX ir 10
					;;; DX - liekana, AX - rezultatas

		add	dl,30h		; prie DL prideda 30h - tam, kad gautusi desimtainis sk
		push	dx		; DX registre esancia reiksme pasideda i steka
		inc	cx		; kiek k traukt is steko, skaicius
		cmp	ax,0		; tikrina: ar AX lygus 0
		ja	Lauk		; jeigu ne, soka i Lauk

Baigti:		pop	dx		; is steko pasiima reiksme i DX
		mov	ah,2		; kreipiasi su 2-a funkcija
		int	21h		
		loop	Baigti		

Exit:		mov	ax,4C00h	; kreipiasi su 4C00h funkcija
		int	21h		
	
main		endp			
end		main			